/****************************************************************************
** Form implementation generated from reading ui file 'adslwindow.ui'
**
** Created: pią lip 21 08:34:20 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.6   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "adslwindow.h"

#include <qvariant.h>
#include <qsplitter.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qfiledialog.h>
#include <qptrlist.h>
#include <qtextcodec.h>
#include <qpicture.h>

#define LIST "/usr/share/adsl-manager-client/vpi.lst"

/*
 *  Constructs a ADSLWindow as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ADSLWindow::ADSLWindow( QString l, QPixmap i, QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ADSLWindow" );
    setSizeGripEnabled( TRUE );
	setIcon( i );

	locale = l;

    splitter1 = new QSplitter( this, "splitter1" );
    splitter1->setGeometry( QRect( 10, 230, 425, 25 ) );
    splitter1->setOrientation( QSplitter::Horizontal );


	pixmapLabel2 = new QLabel( splitter1, "pixmapLabel2" );
    pixmapLabel2->setPixmap( QPixmap( "/usr/share/adsl-manager-client/pixmaps/logo.png" ) );
    pixmapLabel2->setScaledContents( TRUE );

    okButton = new QPushButton( splitter1, "okButton" );
    okButton->setAutoDefault( TRUE );
    okButton->setDefault( TRUE );

    cancelButton = new QPushButton( splitter1, "cancelButton" );
    cancelButton->setAutoDefault( TRUE );

    ispLabel = new QLabel( this, "ispLabel" );
    ispLabel->setGeometry( QRect( 30, 190, 61, 20 ) );

    ispBox = new QComboBox( FALSE, this, "ispBox" );
    ispBox->setGeometry( QRect( 110, 190, 325, 23 ) );

    countryLabel = new QLabel( this, "countryLabel" );
    countryLabel->setGeometry( QRect( 30, 150, 61, 20 ) );

    countryBox = new QComboBox( FALSE, this, "countryBox" );
    countryBox->setGeometry( QRect( 110, 150, 325, 23 ) );

    passLine = new QLineEdit( this, "passLine" );
    passLine->setGeometry( QRect( 110, 110, 325, 23 ) );

    userLine = new QLineEdit( this, "userLine" );
    userLine->setGeometry( QRect( 110, 70, 325, 23 ) );

    passLabel = new QLabel( this, "passLabel" );
    passLabel->setGeometry( QRect( 30, 110, 61, 20 ) );

    userLabel = new QLabel( this, "userLabel" );
    userLabel->setGeometry( QRect( 30, 70, 70, 20 ) );

    titleLabel = new QLabel( this, "titleLabel" );
    titleLabel->setGeometry( QRect( 100, 25, 255, 25 ) );
    languageChange();
    resize( QSize(450, 264).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
	
    // signals and slots connections
    connect( okButton, SIGNAL( clicked() ), this, SLOT( wrapData() ) );
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( closeWindow() ) );
	connect( countryBox, SIGNAL( activated( int ) ), this, SLOT( countryChanged( int ) ) );

}

/*
 *  Destroys the object and frees any allocated resources
 */
ADSLWindow::~ADSLWindow()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ADSLWindow::languageChange()
{
    setCaption( tr( "Modem configuration" ) );
    okButton->setText( tr( "&OK" ) );
    okButton->setAccel( QKeySequence( QString::null ) );
    cancelButton->setText( tr( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( QString::null ) );
    ispLabel->setText( tr( "Operator:" ) );
    countryLabel->setText( tr( "Country:" ) );
    passLabel->setText( tr( "Password:" ) );
    userLabel->setText( tr( "Username:" ) );
	
    //titleLabel->setText( tr( "<font size=\"+1\"><b>modem configuration</b></font>" ) );
}

void ADSLWindow::setType( int t )
{
	type = t;

	switch( type )
	{
		case 2:
			titleLabel->setText( tr( "<font size=\"+1\"><b>Sagem modem configuration</b></font>" ) );
			break;
		case 3:
			titleLabel->setText( tr( "<font size=\"+1\"><b>Thomson modem configuration</b></font>" ) );
			break;
	}
}

void ADSLWindow::wrapData( )
{

	QString modem_type, path = "nopath";
	int vpi, vci;

	if( window_lock ) return;

	switch( type )
	{
		case 2:
			modem_type = "sagem";
			break;
		case 3:
			modem_type = "speedtouch";
			path = QFileDialog::getOpenFileName( QDir::homeDirPath( ), "Archives (*.zip)", this, tr( "Select file with firmware" ) );
			break;
			
	}	

	if( path == QString::null )
	{
		closeCancel( );
		return;
	}

	getStuff( vpi, vci );

	if( path == "nopath" ) path = "";

	window_lock = 1;

	emit data( modem_type, userLine->text( ), passLine->text( ), vpi, vci, path );

	accept( );
}

void ADSLWindow::closeWindow( )
{
	emit closeCancel( );
	reject( );
}

void ADSLWindow::showWindow( int t )
{
	parseFile( );
	setType( t );
        if( locale == "pl" )
        {
                countryBox->setCurrentItem( 3 );
                countryChanged( 3 );
        }
	
	window_lock = 0;

	exec( );
}

void ADSLWindow::parseFile( )
{
	QFile f( LIST );
	f.open( IO_ReadOnly );
	
	QString line;
	QStringList * isp = new QStringList;
		
	QTextCodec * codec = QTextCodec::codecForName( "utf8" );

	while( f.readLine( line, 70 ) != -1 )
	{

		if( line[0] == '[' && !line.contains( "end" ) ) 
		{
			country.append( line.mid( 1, line.length( ) - 3 ) );
			isp = new QStringList;
			continue;			
		}

		if( line.contains( "operator=" ) )
		{
			isp->append( codec->toUnicode( line.section( '=', 1, 1 ) ) );
			continue;
		}
			
		if( line.contains( "[end" ) )	
		{
			provider.append( isp );	
			continue;
		}
		
	}

	f.close( );

	for( int i = 0; i < country.count( ); i++ )
	{
		countryBox->insertItem( codec->toUnicode( country[i] ) );
	}
	
	QStringList * list = provider.at( 0 );
	ispBox->insertStringList( *list );


}

void ADSLWindow::getStuff( int &vpi, int &vci )
{
	QFile f( LIST );
	f.open( IO_ReadOnly );

	QString line;
	int c = 1;

	while( f.readLine( line, 70 ) != -1 )
	{
		if( c && line.contains( countryBox->currentText( ) ) )
		{
			c = 0;
		}

		if( !c && line.contains( ispBox->currentText( ) ) )
		{
			for( int i = 1; i <= 2; i++ )
			{
				f.readLine( line, 70 );
				if( line.contains( "vpi" ) ) vpi = line.section( '=', 1, 1 ).toInt( );
				if( line.contains( "vci" ) ) vci = line.section( '=', 1, 1 ).toInt( );
			}
		}
	}

	f.close( );
}

void ADSLWindow::countryChanged( int pos ) 
{
	ispBox->clear( );
	QStringList * list = provider.at( pos  );
	ispBox->insertStringList( *list );
}
