#ifndef CLIENT_H
#define CLIENT_H

#include <qobject.h>
#include <ksystemtray.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <qtimer.h>

class QSocket;
class QProcess;
class GPRSWindow;
class ADSLWindow;

class Client : public QObject
{
	Q_OBJECT

	public:
		Client( QString );
		~Client( );

		void	setUpTray( );
		void	trayConnect( );
		void	trayDisconnect( );

	public slots:
		void 	command( char * );
		void	choice( int );
		void	quit( );
		void	readSockData( );
		void	checkModem( );	
		void	checkConnection( );
		void	readStatus( );
		void	gprsData( int, QString );
		void	adslData( QString, QString, QString, int, int, QString );
		void	confWindowCancel( );

	private:
		KSystemTray		* tray;
		char			* last_command;
		int 			s;
		struct sockaddr_un 	servsock;
		int 			modem_status;
		int			connection;
		int			new_modem;
		int			first_config;
		int			connecting;
		int			share_type;

		QSocket			* sock;
		QTimer			* timer;
		QProcess		* process;
		
		GPRSWindow		* gprsWindow;
		ADSLWindow		* adslWindow;


		

};

#endif
